package com.alibaba.fastjson;

import com.alibaba.fastjson.serializer.JSONSerializable;
import com.alibaba.fastjson.serializer.JSONSerializer;
import com.alibaba.fastjson.serializer.SerializeWriter;
import com.alibaba.fastjson.serializer.SerializerFeature;
import java.io.IOException;
import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.List;

public class JSONPObject implements JSONSerializable {
   public static String SECURITY_PREFIX = "/**/";
   private String function;
   private static final int BrowserSecureMask;
   private final List<Object> parameters = new ArrayList();

   public JSONPObject() {
   }

   public JSONPObject(String function) {
      this.function = function;
   }

   public String getFunction() {
      return this.function;
   }

   public void setFunction(String function) {
      this.function = function;
   }

   public List<Object> getParameters() {
      return this.parameters;
   }

   public void addParameter(Object parameter) {
      this.parameters.add(parameter);
   }

   public String toJSONString() {
      return this.toString();
   }

   public void write(JSONSerializer serializer, Object fieldName, Type fieldType, int features) throws IOException {
      SerializeWriter writer = serializer.out;
      if ((features & BrowserSecureMask) != 0 || writer.isEnabled(BrowserSecureMask)) {
         writer.write(SECURITY_PREFIX);
      }

      writer.write(this.function);
      writer.write(40);

      for(int i = 0; i < this.parameters.size(); ++i) {
         if (i != 0) {
            writer.write(44);
         }

         serializer.write(this.parameters.get(i));
      }

      writer.write(41);
   }

   public String toString() {
      return JSON.toJSONString(this);
   }

   static {
      BrowserSecureMask = SerializerFeature.BrowserSecure.mask;
   }
}
