package com.alibaba.fastjson;

public enum PropertyNamingStrategy {
   CamelCase,
   PascalCase,
   SnakeCase,
   KebabCase;

   public String translate(String propertyName) {
      char ch;
      char[] chars;
      char ch;
      char ch_ucase;
      StringBuilder buf;
      int i;
      switch(this) {
      case SnakeCase:
         buf = new StringBuilder();
         i = 0;

         for(; i < propertyName.length(); ++i) {
            ch = propertyName.charAt(i);
            if (ch >= 'A' && ch <= 'Z') {
               ch_ucase = (char)(ch + 32);
               if (i > 0) {
                  buf.append('_');
               }

               buf.append(ch_ucase);
            } else {
               buf.append(ch);
            }
         }

         return buf.toString();
      case KebabCase:
         buf = new StringBuilder();

         for(i = 0; i < propertyName.length(); ++i) {
            ch = propertyName.charAt(i);
            if (ch >= 'A' && ch <= 'Z') {
               ch_ucase = (char)(ch + 32);
               if (i > 0) {
                  buf.append('-');
               }

               buf.append(ch_ucase);
            } else {
               buf.append(ch);
            }
         }

         return buf.toString();
      case PascalCase:
         ch = propertyName.charAt(0);
         if (ch >= 'a' && ch <= 'z') {
            chars = propertyName.toCharArray();
            chars[0] = (char)(chars[0] - 32);
            return new String(chars);
         }

         return propertyName;
      case CamelCase:
         ch = propertyName.charAt(0);
         if (ch >= 'A' && ch <= 'Z') {
            chars = propertyName.toCharArray();
            chars[0] = (char)(chars[0] + 32);
            return new String(chars);
         }

         return propertyName;
      default:
         return propertyName;
      }
   }
}
