package com.alibaba.fastjson.asm;

public class Label {
   int status;
   int position;
   private int referenceCount;
   private int[] srcAndRefPositions;
   int inputStackTop;
   int outputStackMax;
   Label successor;
   Label next;

   void put(MethodWriter owner, ByteVector out, int source) {
      if ((this.status & 2) == 0) {
         this.addReference(source, out.length);
         out.putShort(-1);
      } else {
         out.putShort(this.position - source);
      }

   }

   private void addReference(int sourcePosition, int referencePosition) {
      if (this.srcAndRefPositions == null) {
         this.srcAndRefPositions = new int[6];
      }

      if (this.referenceCount >= this.srcAndRefPositions.length) {
         int[] a = new int[this.srcAndRefPositions.length + 6];
         System.arraycopy(this.srcAndRefPositions, 0, a, 0, this.srcAndRefPositions.length);
         this.srcAndRefPositions = a;
      }

      this.srcAndRefPositions[this.referenceCount++] = sourcePosition;
      this.srcAndRefPositions[this.referenceCount++] = referencePosition;
   }

   void resolve(MethodWriter owner, int position, byte[] data) {
      this.status |= 2;
      this.position = position;

      int reference;
      int offset;
      for(int i = 0; i < this.referenceCount; data[reference] = (byte)offset) {
         int source = this.srcAndRefPositions[i++];
         reference = this.srcAndRefPositions[i++];
         offset = position - source;
         data[reference++] = (byte)(offset >>> 8);
      }

   }
}
