package com.alibaba.fastjson.parser;

public enum Feature {
   AutoCloseSource,
   AllowComment,
   AllowUnQuotedFieldNames,
   AllowSingleQuotes,
   InternFieldNames,
   AllowISO8601DateFormat,
   AllowArbitraryCommas,
   UseBigDecimal,
   IgnoreNotMatch,
   SortFeidFastMatch,
   DisableASM,
   DisableCircularReferenceDetect,
   InitStringFieldAsEmpty,
   SupportArrayToBean,
   OrderedField,
   DisableSpecialKeyDetect,
   UseObjectArray,
   SupportNonPublicField,
   IgnoreAutoType,
   DisableFieldSmartMatch,
   SupportAutoType,
   NonStringKeyAsString,
   CustomMapDeserializer;

   public final int mask = 1 << this.ordinal();

   public final int getMask() {
      return this.mask;
   }

   public static boolean isEnabled(int features, Feature feature) {
      return (features & feature.mask) != 0;
   }

   public static int config(int features, Feature feature, boolean state) {
      if (state) {
         features |= feature.mask;
      } else {
         features &= ~feature.mask;
      }

      return features;
   }

   public static int of(Feature[] features) {
      if (features == null) {
         return 0;
      } else {
         int value = 0;
         Feature[] var2 = features;
         int var3 = features.length;

         for(int var4 = 0; var4 < var3; ++var4) {
            Feature feature = var2[var4];
            value |= feature.mask;
         }

         return value;
      }
   }
}
