package com.alibaba.fastjson.parser;

import java.lang.reflect.Type;

public class ParseContext {
   public Object object;
   public final ParseContext parent;
   public final Object fieldName;
   public Type type;
   private transient String path;

   public ParseContext(ParseContext parent, Object object, Object fieldName) {
      this.parent = parent;
      this.object = object;
      this.fieldName = fieldName;
   }

   public String toString() {
      if (this.path == null) {
         if (this.parent == null) {
            this.path = "$";
         } else if (this.fieldName instanceof Integer) {
            this.path = this.parent.toString() + "[" + this.fieldName + "]";
         } else {
            this.path = this.parent.toString() + "." + this.fieldName;
         }
      }

      return this.path;
   }
}
