package com.alibaba.fastjson.serializer;

public abstract class AfterFilter implements SerializeFilter {
   private static final ThreadLocal<JSONSerializer> serializerLocal = new ThreadLocal();
   private static final ThreadLocal<Character> seperatorLocal = new ThreadLocal();
   private static final Character COMMA = ',';

   final char writeAfter(JSONSerializer serializer, Object object, char seperator) {
      serializerLocal.set(serializer);
      seperatorLocal.set(seperator);
      this.writeAfter(object);
      serializerLocal.set((Object)null);
      return (Character)seperatorLocal.get();
   }

   protected final void writeKeyValue(String key, Object value) {
      JSONSerializer serializer = (JSONSerializer)serializerLocal.get();
      char seperator = (Character)seperatorLocal.get();
      serializer.writeKeyValue(seperator, key, value);
      if (seperator != ',') {
         seperatorLocal.set(COMMA);
      }

   }

   public abstract void writeAfter(Object var1);
}
