package com.alibaba.fastjson.serializer;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.lang.reflect.Type;
import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;
import sun.reflect.annotation.AnnotationType;

public class AnnotationSerializer implements ObjectSerializer {
   public static AnnotationSerializer instance = new AnnotationSerializer();

   public void write(JSONSerializer serializer, Object object, Object fieldName, Type fieldType, int features) throws IOException {
      Class objClass = object.getClass();
      Class[] interfaces = objClass.getInterfaces();
      if (interfaces.length == 1 && interfaces[0].isAnnotation()) {
         Class annotationClass = interfaces[0];
         AnnotationType type = AnnotationType.getInstance(annotationClass);
         Map<String, Method> members = type.members();
         JSONObject json = new JSONObject(members.size());
         Iterator<Entry<String, Method>> iterator = members.entrySet().iterator();

         Entry entry;
         for(Object val = null; iterator.hasNext(); json.put((String)entry.getKey(), JSON.toJSON(val))) {
            entry = (Entry)iterator.next();

            try {
               val = ((Method)entry.getValue()).invoke(object);
            } catch (IllegalAccessException var16) {
            } catch (InvocationTargetException var17) {
            }
         }

         serializer.write((Object)json);
      }
   }
}
