package com.alibaba.fastjson.serializer;

import com.alibaba.fastjson.JSONException;
import java.io.IOException;
import java.io.Reader;
import java.lang.reflect.Type;
import java.sql.Clob;
import java.sql.SQLException;

public class ClobSeriliazer implements ObjectSerializer {
   public static final ClobSeriliazer instance = new ClobSeriliazer();

   public void write(JSONSerializer serializer, Object object, Object fieldName, Type fieldType, int features) throws IOException {
      try {
         if (object == null) {
            serializer.writeNull();
         } else {
            Clob clob = (Clob)object;
            Reader reader = clob.getCharacterStream();
            StringBuilder buf = new StringBuilder();

            try {
               char[] chars = new char[2048];

               while(true) {
                  int len = reader.read(chars, 0, chars.length);
                  if (len < 0) {
                     break;
                  }

                  buf.append(chars, 0, len);
               }
            } catch (Exception var11) {
               throw new JSONException("read string from reader error", var11);
            }

            String text = buf.toString();
            reader.close();
            serializer.write(text);
         }
      } catch (SQLException var12) {
         throw new IOException("write clob error", var12);
      }
   }
}
