package com.alibaba.fastjson.serializer;

import java.util.Arrays;

public class Labels {
   public static LabelFilter includes(String... views) {
      return new Labels.DefaultLabelFilter(views, (String[])null);
   }

   public static LabelFilter excludes(String... views) {
      return new Labels.DefaultLabelFilter((String[])null, views);
   }

   private static class DefaultLabelFilter implements LabelFilter {
      private String[] includes;
      private String[] excludes;

      public DefaultLabelFilter(String[] includes, String[] excludes) {
         if (includes != null) {
            this.includes = new String[includes.length];
            System.arraycopy(includes, 0, this.includes, 0, includes.length);
            Arrays.sort(this.includes);
         }

         if (excludes != null) {
            this.excludes = new String[excludes.length];
            System.arraycopy(excludes, 0, this.excludes, 0, excludes.length);
            Arrays.sort(this.excludes);
         }

      }

      public boolean apply(String label) {
         if (this.excludes != null) {
            return Arrays.binarySearch(this.excludes, label) == -1;
         } else {
            return this.includes != null && Arrays.binarySearch(this.includes, label) >= 0;
         }
      }
   }
}
