package com.alibaba.fastjson.serializer;

public class SerialContext {
   public final SerialContext parent;
   public final Object object;
   public final Object fieldName;
   public final int features;

   public SerialContext(SerialContext parent, Object object, Object fieldName, int features, int fieldFeatures) {
      this.parent = parent;
      this.object = object;
      this.fieldName = fieldName;
      this.features = features;
   }

   public String toString() {
      if (this.parent == null) {
         return "$";
      } else {
         StringBuilder buf = new StringBuilder();
         this.toString(buf);
         return buf.toString();
      }
   }

   protected void toString(StringBuilder buf) {
      if (this.parent == null) {
         buf.append('$');
      } else {
         this.parent.toString(buf);
         if (this.fieldName == null) {
            buf.append(".null");
         } else if (this.fieldName instanceof Integer) {
            buf.append('[');
            buf.append((Integer)this.fieldName);
            buf.append(']');
         } else {
            buf.append('.');
            String fieldName = this.fieldName.toString();
            boolean special = false;

            int i;
            char ch;
            for(i = 0; i < fieldName.length(); ++i) {
               ch = fieldName.charAt(i);
               if (ch == '.' || ch == '@' || ch == '(' || ch == '\\') {
                  special = true;
               }
            }

            if (special) {
               for(i = 0; i < fieldName.length(); ++i) {
                  ch = fieldName.charAt(i);
                  if (ch != '.' && ch != '@' && ch != '(') {
                     if (ch == '\\') {
                        buf.append('\\');
                        buf.append('\\');
                        buf.append('\\');
                     }
                  } else {
                     buf.append('\\');
                     buf.append('\\');
                  }

                  buf.append(ch);
               }
            } else {
               buf.append(fieldName);
            }
         }
      }

   }

   /** @deprecated */
   public SerialContext getParent() {
      return this.parent;
   }

   /** @deprecated */
   public Object getObject() {
      return this.object;
   }

   /** @deprecated */
   public Object getFieldName() {
      return this.fieldName;
   }

   /** @deprecated */
   public String getPath() {
      return this.toString();
   }
}
