package com.alibaba.fastjson.support.spring;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.serializer.JSONSerializer;
import com.alibaba.fastjson.serializer.SerializeWriter;
import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.Type;
import org.springframework.web.socket.sockjs.frame.AbstractSockJsMessageCodec;

public class FastjsonSockJsMessageCodec extends AbstractSockJsMessageCodec {
   public String[] decode(String content) throws IOException {
      return (String[])JSON.parseObject(content, String[].class);
   }

   public String[] decodeInputStream(InputStream content) throws IOException {
      return (String[])JSON.parseObject((InputStream)content, (Type)String[].class);
   }

   protected char[] applyJsonQuoting(String content) {
      SerializeWriter out = new SerializeWriter();

      char[] var4;
      try {
         JSONSerializer serializer = new JSONSerializer(out);
         serializer.write(content);
         var4 = out.toCharArrayForSpringWebSocket();
      } finally {
         out.close();
      }

      return var4;
   }
}
