package com.alibaba.fastjson.support.spring;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.parser.ParserConfig;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.alibaba.fastjson.util.IOUtils;
import java.lang.reflect.Type;
import org.springframework.data.redis.serializer.RedisSerializer;
import org.springframework.data.redis.serializer.SerializationException;

public class GenericFastJsonRedisSerializer implements RedisSerializer<Object> {
   private static final ParserConfig defaultRedisConfig = new ParserConfig();

   public byte[] serialize(Object object) throws SerializationException {
      if (object == null) {
         return new byte[0];
      } else {
         try {
            return JSON.toJSONBytes(object, SerializerFeature.WriteClassName);
         } catch (Exception var3) {
            throw new SerializationException("Could not serialize: " + var3.getMessage(), var3);
         }
      }
   }

   public Object deserialize(byte[] bytes) throws SerializationException {
      if (bytes != null && bytes.length != 0) {
         try {
            return JSON.parseObject((String)(new String(bytes, IOUtils.UTF8)), (Type)Object.class, (ParserConfig)defaultRedisConfig);
         } catch (Exception var3) {
            throw new SerializationException("Could not deserialize: " + var3.getMessage(), var3);
         }
      } else {
         return null;
      }
   }

   static {
      defaultRedisConfig.setAutoTypeSupport(true);
   }
}
