package com.alibaba.fastjson.support.spring.messaging;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.support.config.FastJsonConfig;
import java.nio.charset.Charset;
import org.springframework.messaging.Message;
import org.springframework.messaging.MessageHeaders;
import org.springframework.messaging.converter.AbstractMessageConverter;
import org.springframework.util.MimeType;

public class MappingFastJsonMessageConverter extends AbstractMessageConverter {
   private FastJsonConfig fastJsonConfig = new FastJsonConfig();

   public FastJsonConfig getFastJsonConfig() {
      return this.fastJsonConfig;
   }

   public void setFastJsonConfig(FastJsonConfig fastJsonConfig) {
      this.fastJsonConfig = fastJsonConfig;
   }

   public MappingFastJsonMessageConverter() {
      super(new MimeType("application", "json", Charset.forName("UTF-8")));
   }

   protected boolean supports(Class<?> clazz) {
      return true;
   }

   protected boolean canConvertFrom(Message<?> message, Class<?> targetClass) {
      return this.supports(targetClass);
   }

   protected boolean canConvertTo(Object payload, MessageHeaders headers) {
      return this.supports(payload.getClass());
   }

   protected Object convertFromInternal(Message<?> message, Class<?> targetClass, Object conversionHint) {
      Object payload = message.getPayload();
      Object obj = null;
      if (payload instanceof byte[]) {
         obj = JSON.parseObject((byte[])((byte[])payload), 0, ((byte[])((byte[])payload)).length, (Charset)this.fastJsonConfig.getCharset(), targetClass, this.fastJsonConfig.getFeatures());
      } else if (payload instanceof String) {
         obj = JSON.parseObject((String)payload, targetClass, this.fastJsonConfig.getFeatures());
      }

      return obj;
   }

   protected Object convertToInternal(Object payload, MessageHeaders headers, Object conversionHint) {
      return JSON.toJSONString(payload, this.fastJsonConfig.getSerializeConfig(), this.fastJsonConfig.getSerializeFilters(), this.fastJsonConfig.getSerializerFeatures());
   }
}
