package com.alibaba.fastjson.util;

import java.util.Arrays;

/** @deprecated */
public class Base64 {
   public static final char[] CA = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".toCharArray();
   public static final int[] IA = new int[256];

   public static byte[] decodeFast(char[] chars, int offset, int charsLen) {
      if (charsLen == 0) {
         return new byte[0];
      } else {
         int sIx = offset;

         int eIx;
         for(eIx = offset + charsLen - 1; sIx < eIx && IA[chars[sIx]] < 0; ++sIx) {
         }

         while(eIx > 0 && IA[chars[eIx]] < 0) {
            --eIx;
         }

         int pad = chars[eIx] == '=' ? (chars[eIx - 1] == '=' ? 2 : 1) : 0;
         int cCnt = eIx - sIx + 1;
         int sepCnt = charsLen > 76 ? (chars[76] == '\r' ? cCnt / 78 : 0) << 1 : 0;
         int len = ((cCnt - sepCnt) * 6 >> 3) - pad;
         byte[] bytes = new byte[len];
         int d = 0;
         int i = 0;
         int r = len / 3 * 3;

         while(d < r) {
            int i = IA[chars[sIx++]] << 18 | IA[chars[sIx++]] << 12 | IA[chars[sIx++]] << 6 | IA[chars[sIx++]];
            bytes[d++] = (byte)(i >> 16);
            bytes[d++] = (byte)(i >> 8);
            bytes[d++] = (byte)i;
            if (sepCnt > 0) {
               ++i;
               if (i == 19) {
                  sIx += 2;
                  i = 0;
               }
            }
         }

         if (d < len) {
            i = 0;

            for(r = 0; sIx <= eIx - pad; ++r) {
               i |= IA[chars[sIx++]] << 18 - r * 6;
            }

            for(r = 16; d < len; r -= 8) {
               bytes[d++] = (byte)(i >> r);
            }
         }

         return bytes;
      }
   }

   public static byte[] decodeFast(String chars, int offset, int charsLen) {
      if (charsLen == 0) {
         return new byte[0];
      } else {
         int sIx = offset;

         int eIx;
         for(eIx = offset + charsLen - 1; sIx < eIx && IA[chars.charAt(sIx)] < 0; ++sIx) {
         }

         while(eIx > 0 && IA[chars.charAt(eIx)] < 0) {
            --eIx;
         }

         int pad = chars.charAt(eIx) == '=' ? (chars.charAt(eIx - 1) == '=' ? 2 : 1) : 0;
         int cCnt = eIx - sIx + 1;
         int sepCnt = charsLen > 76 ? (chars.charAt(76) == '\r' ? cCnt / 78 : 0) << 1 : 0;
         int len = ((cCnt - sepCnt) * 6 >> 3) - pad;
         byte[] bytes = new byte[len];
         int d = 0;
         int i = 0;
         int r = len / 3 * 3;

         while(d < r) {
            int i = IA[chars.charAt(sIx++)] << 18 | IA[chars.charAt(sIx++)] << 12 | IA[chars.charAt(sIx++)] << 6 | IA[chars.charAt(sIx++)];
            bytes[d++] = (byte)(i >> 16);
            bytes[d++] = (byte)(i >> 8);
            bytes[d++] = (byte)i;
            if (sepCnt > 0) {
               ++i;
               if (i == 19) {
                  sIx += 2;
                  i = 0;
               }
            }
         }

         if (d < len) {
            i = 0;

            for(r = 0; sIx <= eIx - pad; ++r) {
               i |= IA[chars.charAt(sIx++)] << 18 - r * 6;
            }

            for(r = 16; d < len; r -= 8) {
               bytes[d++] = (byte)(i >> r);
            }
         }

         return bytes;
      }
   }

   public static byte[] decodeFast(String s) {
      int sLen = s.length();
      if (sLen == 0) {
         return new byte[0];
      } else {
         int sIx = 0;

         int eIx;
         for(eIx = sLen - 1; sIx < eIx && IA[s.charAt(sIx) & 255] < 0; ++sIx) {
         }

         while(eIx > 0 && IA[s.charAt(eIx) & 255] < 0) {
            --eIx;
         }

         int pad = s.charAt(eIx) == '=' ? (s.charAt(eIx - 1) == '=' ? 2 : 1) : 0;
         int cCnt = eIx - sIx + 1;
         int sepCnt = sLen > 76 ? (s.charAt(76) == '\r' ? cCnt / 78 : 0) << 1 : 0;
         int len = ((cCnt - sepCnt) * 6 >> 3) - pad;
         byte[] dArr = new byte[len];
         int d = 0;
         int i = 0;
         int r = len / 3 * 3;

         while(d < r) {
            int i = IA[s.charAt(sIx++)] << 18 | IA[s.charAt(sIx++)] << 12 | IA[s.charAt(sIx++)] << 6 | IA[s.charAt(sIx++)];
            dArr[d++] = (byte)(i >> 16);
            dArr[d++] = (byte)(i >> 8);
            dArr[d++] = (byte)i;
            if (sepCnt > 0) {
               ++i;
               if (i == 19) {
                  sIx += 2;
                  i = 0;
               }
            }
         }

         if (d < len) {
            i = 0;

            for(r = 0; sIx <= eIx - pad; ++r) {
               i |= IA[s.charAt(sIx++)] << 18 - r * 6;
            }

            for(r = 16; d < len; r -= 8) {
               dArr[d++] = (byte)(i >> r);
            }
         }

         return dArr;
      }
   }

   static {
      Arrays.fill(IA, -1);
      int i = 0;

      for(int iS = CA.length; i < iS; IA[CA[i]] = i++) {
      }

      IA[61] = 0;
   }
}
